    001/*
    002 * Licensed to the Apache Software Foundation (ASF) under one
    003 * or more contributor license agreements.  See the NOTICE file
    004 * distributed with this work for additional information
    005 * regarding copyright ownership.  The ASF licenses this file
    006 * to you under the Apache License, Version 2.0 (the
    007 * "License"); you may not use this file except in compliance
    008 * with the License.  You may obtain a copy of the License at
    009 *
    010 * http://www.apache.org/licenses/LICENSE-2.0
    011 *
    012 * Unless required by applicable law or agreed to in writing,
    013 * software distributed under the License is distributed on an
    014 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015 * KIND, either express or implied.  See the License for the
    016 * specific language governing permissions and limitations
    017 * under the License.
    018 */
    019package org.apache.commons.compress.compressors.deflate;
    020
    021import java.io.IOException;
    022import java.io.OutputStream;
    023import java.util.zip.Deflater;
    024import java.util.zip.DeflaterOutputStream;
    025
    026import org.apache.commons.compress.compressors.CompressorOutputStream;
    027
    028/**
    029 * Deflate compressor.
    030 * @since 1.9
    031 */
    032public class DeflateCompressorOutputStream extends CompressorOutputStream {
    033    private final DeflaterOutputStream out;
    034    private final Deflater deflater;
    035
    036    /**
    037     * Creates a Deflate compressed output stream with the default parameters.
    038     * @param outputStream the stream to wrap
    039     * @throws IOException on error
    040     */
    041    public DeflateCompressorOutputStream(final OutputStream outputStream) throws IOException {
    042        this(outputStream, new DeflateParameters());
    043    }
    044
    045    /**
    046     * Creates a Deflate compressed output stream with the specified parameters.
    047     * @param outputStream the stream to wrap
    048     * @param parameters the deflate parameters to apply
    049     * @throws IOException on error
    050     */
    051    public DeflateCompressorOutputStream(final OutputStream outputStream,
    052                                         final DeflateParameters parameters) throws IOException {
    053        this.deflater = new Deflater(parameters.getCompressionLevel(), !parameters.withZlibHeader());
    054        this.out = new DeflaterOutputStream(outputStream, deflater);
    055    }
    056
    057    @Override
    058    public void write(final int b) throws IOException {
    059        out.write(b);
    060    }
    061
    062    @Override
    063    public void write(final byte[] buf, final int off, final int len) throws IOException {
    064        out.write(buf, off, len);
    065    }
    066
    067    /**
    068     * Flushes the encoder and calls <code>outputStream.flush()</code>.
    069     * All buffered pending data will then be decompressible from
    070     * the output stream. Calling this function very often may increase
    071     * the compressed file size a lot.
    072     */
    073    @Override
    074    public void flush() throws IOException {
    075        out.flush();
    076    }
    077
    078    /**
    079     * Finishes compression without closing the underlying stream.
    080     * <p>No more data can be written to this stream after finishing.</p>
    081     * @throws IOException on error
    082     */
    083    public void finish() throws IOException {
    084        out.finish();
    085    }
    086
    087    @Override
    088    public void close() throws IOException {
    089        try {
    090            out.close();
    091        } finally {
    092            deflater.end();
    093        }
    094    }
    095}